<template>
  <div>
    <reconnecting-hero :show="isReconnecting" />
    <break-lifecycle v-if="!hasSteps" />
    <inactive-lifecycle v-else-if="started" />
    <active-lifecycle v-else />
    <call-button />
  </div>
</template>
<script>
import { mapGetters } from 'vuex';
import { DateTime } from 'luxon';
import activeLifecycle from '~/components/lifecycle/active.vue';
import breakLifecycle from '~/components/lifecycle/break.vue';
import callButton from '~/components/elements/call-button.vue';
import inactiveLifecycle from '~/components/lifecycle/inactive.vue';
import reconnectingHero from '~/components/reconnecting-hero.vue';

const getISOStepsInterval = (day) => {
  const dayInDateTime = day ? DateTime.fromFormat(day, 'yyyy-MM-dd') : DateTime.local();
  const before = dayInDateTime.endOf('day');
  const after = dayInDateTime.startOf('day');
  return [before.toISO(), after.toISO()];
};

export default {
  components: {
    activeLifecycle,
    breakLifecycle,
    callButton,
    inactiveLifecycle,
    reconnectingHero,
  },
  async asyncData({
    params: { campus }, store, redirect, query,
  }) {
    if (!campus) {
      redirect('/');
    }
    await store.dispatch('context/setCampus', campus);
    const [before, after] = getISOStepsInterval(query.day);
    await store.dispatch('steps/fetchSteps', { campus, before, after });
    return { campus };
  },
  data() {
    return {
      started: false,
    };
  },
  computed: {
    ...mapGetters({
      hasSteps: 'steps/hasSteps',
      isReconnecting: 'isReconnecting',
    }),
  },
  watch: {
    async isReconnecting() {
      if (!this.isReconnecting) {
        const { day } = this.$route.query;
        const [before, after] = getISOStepsInterval(day);
        await this.$store.dispatch('steps/fetchSteps', { campus: this.campus, before, after });
      }
    },
  },
  watchQuery: ['day'],
  mounted() {
    this.$io.emit('driverConnected', { driverId: this.$auth.user.id, campusId: this.$route.params.campus });
  },
};
</script>

<style scoped lang="scss">
  @import "~assets/css/head";
  .notification {
    z-index: 1;
    box-shadow: 0 10px 20px 0 rgba($black, 0.15);
    color: $white;
    /deep/ .tag {
      font-weight: bold;
    }
    &.is-gray {
      background-color: $gray;
      /deep/ .tag {
        color: $gray;
      }
    }
    &.is-primary /deep/ .tag {
      color: $primary;
    }
    &.is-warning /deep/ .tag {
      color: $warning;
    }
  }

  /deep/ > .box {
    $underNotifCorrection: 40px;
    margin-top: -$underNotifCorrection;
    padding-top: $underNotifCorrection;
    margin-bottom: $underNotifCorrection;
  }
  @keyframes alarmDate {
    0% { color: $white; }
    50% { color: $warning; }
    100% { color: $white; }
  }
  .pretitle {
    text-transform: uppercase;
    max-width: 250px;
    font-weight: bold;
    &.is-not-today {
      animation: alarmDate 4s infinite;
    }
  }

  .no-rides {
    padding: 15px;
    font-size: $size-4;
  }

  .poi {
    font-size: $size-1;
    line-height: $size-2;
    padding-top: $size-7;
    padding-bottom: $size-7;
    font-weight: bold;
    &-label {
      font-size: $size-7;
    }
  }
</style>
